<?php
use GraphQL\Type\Definition\ObjectType;
use GraphQL\Type\Definition\Type;

require "queries/products.php";

$queryType = new ObjectType([
    'name' => 'Query',
    'fields' => [
        "products" => [
            'type' => Type::listOf($product),
            "args" => [
                "limit" => [
                    "type" => Type::int(),
                    "defaultValue" => 100
                ],
                "offset" => [
                    "type" => Type::int(),
                    "defaultValue" => 0
                ]
                ],
                'resolve' => fn ($rootValue, $args) => products($rootValue["db"], $args["limit"], $args["offset"]),
        ],
        "search" => [
            'type' => Type::listOf($product),
            "args" => [
                "limit" => [
                    "type" => Type::int(),
                    "defaultValue" => 100
                ],
                "offset" => [
                    "type" => Type::int(),
                    "defaultValue" => 0
                ],
                "column" => [
                    "type" => Type::string(),
                    "defaultValue" => "name"
                ],
                "search" => Type::nonNull(Type::string())
                ],
                'resolve' => fn ($rootValue, $args) => filterProducts($rootValue["db"], $args["column"], $args["search"], $args["limit"], $args["offset"]),
        ]
    ],
]);
