<?php

use GraphQL\Type\Definition\Type;
use GraphQL\Type\Definition\ObjectType;

$product = new ObjectType([
    "name" => "Product",
    "fields" => [
        "id" => Type::int(),
        "manufacturer" => Type::string(),
        "manufacturerid" => Type::int(),
        "name" => Type::string(),
        "amount" => Type::int(),
        "position" => Type::string(),
        "positionid" => Type::int(),
        "lastUpdate" => Type::int(),
    ]
]);

function products($conn, $limit = -1, $offset = 0)
{
    $limit = $conn->real_escape_string($limit);
    $offset = $conn->real_escape_string($offset);
    $query = "SELECT products.id,
    manufacturer,
    manufacturer.id AS manufacturerid,
    name,
    amount,
    position,
    position.id AS positionid,
    lastUpdate 
    FROM products
    INNER JOIN position ON positionID = position.id
    INNER JOIN manufacturer ON manufacturerID = manufacturer.id";
    if ($limit > 0) {
        $query .= " LIMIT $limit OFFSET $offset";
    }
    $result = $conn->query($query);
    return $result->fetch_all(MYSQLI_ASSOC);
}

function filterProducts($conn, $column, $search, $limit, $offset) {
    $column = $conn->real_escape_string($column);
    $search = $conn->real_escape_string($search);
    $limit = $conn->real_escape_string($limit);
    $offset = $conn->real_escape_string($offset);
    $query = "SELECT products.id,
    manufacturer.id AS manufacturerid,
    `name`,
    amount,
    position.id AS positionid,
    lastUpdate
    FROM products
    INNER JOIN position ON positionID = position.id
    INNER JOIN manufacturer ON manufacturerID = manufacturer.id
    WHERE `$column` LIKE '%$search%'
    ORDER BY lastUpdate DESC";

    if ($limit > 0) {
        $query .= " LIMIT $limit OFFSET $offset";
    }

    $result = $conn->query($query);
    return $result->fetch_all(MYSQLI_ASSOC);
}